'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Types
 */

var FETCH = 'EFFECT_FETCH';

/**
 * Credential middleware
 */

function query(pattern, name, getToken) {
  return function (_ref) {
    var getState = _ref.getState;
    return function (next) {
      return function (action) {
        return action.type === FETCH && pattern.test(action.payload.url) ? next(_extends({}, action, { payload: _extends({}, action.payload, { url: decorate(getState(), action.payload.url) }) })) : next(action);
      };
    };
  };

  function decorate(state, url) {
    var token = getToken(state);
    if (!token) return url;

    var _url$split = url.split('?');

    var _url$split2 = _slicedToArray(_url$split, 2);

    var base = _url$split2[0];
    var _url$split2$ = _url$split2[1];
    var qs = _url$split2$ === undefined ? '' : _url$split2$;

    var param = [name, token].map(encodeURIComponent).join('=');

    return [base, qs.split('&').concat(param).filter(Boolean).join('&')].join('?');
  }
}

function bearer(pattern, getToken) {
  var prefix = arguments.length <= 2 || arguments[2] === undefined ? 'Bearer' : arguments[2];

  return function (_ref2) {
    var getState = _ref2.getState;
    return function (next) {
      return function (action) {
        return action.type === FETCH && pattern.test(action.payload.url) ? next(_extends({}, action, { payload: _extends({}, action.payload, { params: _extends({}, action.payload.params, { headers: decorate(getState(), (action.payload.params || {}).headers) }) }) })) : next(action);
      };
    };
  };

  function decorate(state) {
    var headers = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    var token = getToken(state);
    if (!token) return headers;

    return _extends({}, headers, {
      Authorization: prefix + ' ' + token
    });
  }
}

/**
 * Exports
 */

exports.query = query;
exports.bearer = bearer;